## cppcheck 1.81

=== Makefile ===
# This file is generated by tools/dmake, do not edit.

# To compile with rules, use 'make HAVE_RULES=yes'
ifndef HAVE_RULES
    HAVE_RULES=no
endif

# folder where lib/*.cpp files are located
ifndef SRCDIR
    SRCDIR=lib
endif

ifeq ($(SRCDIR),build)
    ifdef VERIFY
        matchcompiler_S := $(shell python tools/matchcompiler.py --verify)
    else
        matchcompiler_S := $(shell python tools/matchcompiler.py)
    endif
endif

ifdef CFGDIR
    CFG=-DCFGDIR=\"$(CFGDIR)\"
else
    CFG=
endif

RDYNAMIC=-rdynamic
# Set the CPPCHK_GLIBCXX_DEBUG flag. This flag is not used in release Makefiles.
# The _GLIBCXX_DEBUG define doesn't work in Cygwin or other Win32 systems.
ifndef COMSPEC
    ifdef ComSpec
        #### ComSpec is defined on some WIN32's.
        COMSPEC=$(ComSpec)
    endif # ComSpec
endif # COMSPEC

ifdef COMSPEC
    #### Maybe Windows
    ifndef CPPCHK_GLIBCXX_DEBUG
        CPPCHK_GLIBCXX_DEBUG=
    endif # !CPPCHK_GLIBCXX_DEBUG

    ifeq ($(MSYSTEM),MINGW32 MINGW64)
        LDFLAGS=-lshlwapi
    else
        RDYNAMIC=-lshlwapi
    endif
else # !COMSPEC
    uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

    ifeq ($(uname_S),Linux)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # Linux

    ifeq ($(uname_S),GNU/kFreeBSD)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # GNU/kFreeBSD

endif # COMSPEC

# Set the UNDEF_STRICT_ANSI flag to address compile time warnings
# with tinyxml2 and Cygwin.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        UNDEF_STRICT_ANSI=-U__STRICT_ANSI__
    endif # CYGWIN
endif # COMSPEC

ifndef CXX
    CXX=g++
endif

ifeq (clang++, $(findstring clang++,$(CXX)))
    CPPCHK_GLIBCXX_DEBUG=
endif
ifndef CXXFLAGS
    CXXFLAGS=-std=c++0x -O2 -include lib/cxx11emu.h -DNDEBUG -Wall -Wno-sign-compare
endif

ifeq (g++, $(findstring g++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq (clang++, $(findstring clang++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq ($(CXX), c++)
    ifeq ($(shell uname -s), Darwin)
        override CXXFLAGS += -std=c++0x
    endif
endif

ifeq ($(HAVE_RULES),yes)
    override CXXFLAGS += -DHAVE_RULES -DTIXML_USE_STL $(shell pcre-config --cflags)
    ifdef LIBS
        LIBS += $(shell pcre-config --libs)
    else
        LIBS=$(shell pcre-config --libs)
    endif
endif

ifndef PREFIX
    PREFIX=/usr
endif

ifndef INCLUDE_FOR_LIB
    INCLUDE_FOR_LIB=-Ilib -Iexternals/simplecpp -Iexternals/tinyxml
endif

ifndef INCLUDE_FOR_CLI
    INCLUDE_FOR_CLI=-Ilib -Iexternals/simplecpp -Iexternals/tinyxml
endif

ifndef INCLUDE_FOR_TEST
    INCLUDE_FOR_TEST=-Ilib -Icli -Iexternals/simplecpp -Iexternals/tinyxml
endif

BIN=$(DESTDIR)$(PREFIX)/bin

# For 'make man': sudo apt-get install xsltproc docbook-xsl docbook-xml on Linux
DB2MAN?=/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"
MAN_SOURCE=man/cppcheck.1.xml


###### Object Files

LIBOBJ =      $(SRCDIR)/analyzerinfo.o \
              $(SRCDIR)/astutils.o \
              $(SRCDIR)/check.o \
              $(SRCDIR)/check64bit.o \
              $(SRCDIR)/checkassert.o \
              $(SRCDIR)/checkautovariables.o \
              $(SRCDIR)/checkbool.o \
              $(SRCDIR)/checkboost.o \
              $(SRCDIR)/checkbufferoverrun.o \
              $(SRCDIR)/checkclass.o \
              $(SRCDIR)/checkcondition.o \
              $(SRCDIR)/checkexceptionsafety.o \
              $(SRCDIR)/checkfunctions.o \
              $(SRCDIR)/checkinternal.o \
              $(SRCDIR)/checkio.o \
              $(SRCDIR)/checkleakautovar.o \
              $(SRCDIR)/checkmemoryleak.o \
              $(SRCDIR)/checknullpointer.o \
              $(SRCDIR)/checkother.o \
              $(SRCDIR)/checkpostfixoperator.o \
              $(SRCDIR)/checksizeof.o \
              $(SRCDIR)/checkstl.o \
              $(SRCDIR)/checkstring.o \
              $(SRCDIR)/checktype.o \
              $(SRCDIR)/checkuninitvar.o \
              $(SRCDIR)/checkunusedfunctions.o \
              $(SRCDIR)/checkunusedvar.o \
              $(SRCDIR)/checkvaarg.o \
              $(SRCDIR)/cppcheck.o \
              $(SRCDIR)/errorlogger.o \
              $(SRCDIR)/importproject.o \
              $(SRCDIR)/library.o \
              $(SRCDIR)/mathlib.o \
              $(SRCDIR)/path.o \
              $(SRCDIR)/pathmatch.o \
              $(SRCDIR)/platform.o \
              $(SRCDIR)/preprocessor.o \
              $(SRCDIR)/settings.o \
              $(SRCDIR)/suppressions.o \
              $(SRCDIR)/symboldatabase.o \
              $(SRCDIR)/templatesimplifier.o \
              $(SRCDIR)/timer.o \
              $(SRCDIR)/token.o \
              $(SRCDIR)/tokenize.o \
              $(SRCDIR)/tokenlist.o \
              $(SRCDIR)/valueflow.o

EXTOBJ =      externals/simplecpp/simplecpp.o \
              externals/tinyxml/tinyxml2.o

CLIOBJ =      cli/cmdlineparser.o \
              cli/cppcheckexecutor.o \
              cli/filelister.o \
              cli/main.o \
              cli/threadexecutor.o

TESTOBJ =     test/options.o \
              test/test64bit.o \
              test/testassert.o \
              test/testastutils.o \
              test/testautovariables.o \
              test/testbool.o \
              test/testboost.o \
              test/testbufferoverrun.o \
              test/testcharvar.o \
              test/testclass.o \
              test/testcmdlineparser.o \
              test/testcondition.o \
              test/testconstructors.o \
              test/testcppcheck.o \
              test/testerrorlogger.o \
              test/testexceptionsafety.o \
              test/testfilelister.o \
              test/testfunctions.o \
              test/testgarbage.o \
              test/testimportproject.o \
              test/testincompletestatement.o \
              test/testinternal.o \
              test/testio.o \
              test/testleakautovar.o \
              test/testlibrary.o \
              test/testmathlib.o \
              test/testmemleak.o \
              test/testnullpointer.o \
              test/testoptions.o \
              test/testother.o \
              test/testpath.o \
              test/testpathmatch.o \
              test/testpostfixoperator.o \
              test/testpreprocessor.o \
              test/testrunner.o \
              test/testsamples.o \
              test/testsimplifytemplate.o \
              test/testsimplifytokens.o \
              test/testsimplifytypedef.o \
              test/testsizeof.o \
              test/teststl.o \
              test/teststring.o \
              test/testsuite.o \
              test/testsuppressions.o \
              test/testsymboldatabase.o \
              test/testthreadexecutor.o \
              test/testtimer.o \
              test/testtoken.o \
              test/testtokenize.o \
              test/testtokenlist.o \
              test/testtype.o \
              test/testuninitvar.o \
              test/testunusedfunctions.o \
              test/testunusedprivfunc.o \
              test/testunusedvar.o \
              test/testvaarg.o \
              test/testvalueflow.o \
              test/testvarid.o

.PHONY: run-dmake tags


###### Targets

cppcheck: $(LIBOBJ) $(CLIOBJ) $(EXTOBJ)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

all:	cppcheck testrunner

testrunner: $(TESTOBJ) $(LIBOBJ) $(EXTOBJ) cli/threadexecutor.o cli/cmdlineparser.o cli/cppcheckexecutor.o cli/filelister.o
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

test:	all
	./testrunner

check:	all
	./testrunner -q

checkcfg:	cppcheck validateCFG
	./test/cfg/runtests.sh

dmake:	tools/dmake.o cli/filelister.o $(SRCDIR)/pathmatch.o $(SRCDIR)/path.o externals/simplecpp/simplecpp.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)

run-dmake: dmake
	./dmake

reduce:	tools/reduce.o $(LIBOBJ) $(EXTOBJ)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

clean:
	rm -f build/*.o lib/*.o cli/*.o test/*.o tools/*.o externals/*/*.o testrunner reduce dmake cppcheck cppcheck.1

man:	man/cppcheck.1

man/cppcheck.1:	$(MAN_SOURCE)

	$(XP) $(DB2MAN) $(MAN_SOURCE)

tags:
	ctags -R --exclude=doxyoutput --exclude=test/cfg cli externals gui lib test

install: cppcheck
	install -d ${BIN}
	install cppcheck ${BIN}
	install addons/*.py ${BIN}
	install addons/*/*.py ${BIN}
	install htmlreport/cppcheck-htmlreport ${BIN}
ifdef CFGDIR 
	install -d ${DESTDIR}${CFGDIR}
	install -m 644 cfg/* ${DESTDIR}${CFGDIR}
endif

# Validation of library files:
ConfigFiles := $(wildcard cfg/*.cfg)
ConfigFilesCHECKED := $(patsubst %.cfg,%.checked,$(ConfigFiles))
.PHONY: validateCFG
%.checked:%.cfg
	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
validateCFG: ${ConfigFilesCHECKED}


###### Build

$(SRCDIR)/analyzerinfo.o: lib/analyzerinfo.cpp lib/cxx11emu.h lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/analyzerinfo.o $(SRCDIR)/analyzerinfo.cpp

$(SRCDIR)/astutils.o: lib/astutils.cpp lib/cxx11emu.h lib/astutils.h lib/library.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/mathlib.h lib/standards.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/timer.h lib/symboldatabase.h lib/token.h lib/valueflow.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/astutils.o $(SRCDIR)/astutils.cpp

$(SRCDIR)/check.o: lib/check.cpp lib/cxx11emu.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/check.o $(SRCDIR)/check.cpp

$(SRCDIR)/check64bit.o: lib/check64bit.cpp lib/cxx11emu.h lib/check64bit.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/symboldatabase.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/check64bit.o $(SRCDIR)/check64bit.cpp

$(SRCDIR)/checkassert.o: lib/checkassert.cpp lib/cxx11emu.h lib/checkassert.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/symboldatabase.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/checkassert.o $(SRCDIR)/checkassert.cpp

$(SRCDIR)/checkautovariables.o: lib/checkautovariables.cpp lib/cxx11emu.h lib/checkautovariables.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/astutils.h lib/symboldatabase.h
	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/checkautovariables.o $(SRCDIR)/checkautovariables.cpp

$(SRCDIR)/checkbool.o: lib/checkbool.cpp lib/cxx11emu.h lib/checkbool.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/astutils.h lib/symboldatabase.h

=== debian/changelog ===
cppcheck (1.81-1build1) bionic; urgency=medium

  * No-change rebuild for tinyxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Jan 2018 06:35:26 +0000

cppcheck (1.81-1) unstable; urgency=medium

  * New upstream release.
  * Added patch fix-cxxflags such that flags are added to CXXFLAGS even if
    it is already set.
  * Fixed build of gui subdirectory if CC or CXX contain spaces, e.g., if
    CXX="ccache g++" (Closes: #819947)
  * Suppress lintian warning "extra-license-file" for
    /usr/share/cppcheck/cfg/bsd.cfg.
  * Update Standards-Version to 4.1.1 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Mon, 30 Oct 2017 09:40:44 +0100

=== debian/control ===
Source: cppcheck
Section: devel
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
  docbook-xml, libpcre3-dev, libtinyxml2-dev, qt5-qmake, qtbase5-dev,
  qtbase5-dev-tools, gdb, dh-python, python-all
Standards-Version: 4.1.1
Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
X-Python-Version: >= 2.6

Package: cppcheck
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-pygments
Suggests: cppcheck-gui
Description: tool for static C/C++ code analysis (CLI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers;
  .
  This package contains the command-line interface for cppcheck.

Package: cppcheck-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: tool for static C/C++ code analysis (GUI)
 Cppcheck is a command-line tool that tries to detect bugs that your
 C/C++ compiler doesn't see. It is versatile, and can check non-standard
 code including various compiler extensions, inline assembly code, etc.
 Its internal preprocessor can handle includes, macros, and several
 preprocessor commands. While Cppcheck is highly configurable,
 you can start using it just by giving it a path to the source code.
 .
 It includes checks for:
  * pointers to out-of-scope auto variables;
  * assignment of auto variables to an effective parameter of a function;
  * out-of-bounds errors in arrays and STL;
  * missing class constructors;
  * variables not initialized by a constructor;
  * use of memset, memcpy, etcetera on a class;
  * non-virtual destructors for base classes;
  * operator= not returning a constant reference to itself;
  * use of deprecated functions (mktemp, gets, scanf);
  * exceptions thrown in destructors;
  * memory leaks in class or function variables;
  * C-style pointer cast in C++ code;
  * redundant if;
  * misuse of the strtol or sprintf functions;
  * unsigned division or division by zero;
  * unused functions and struct members;
  * passing parameters by value;
  * misuse of signed char variables;
  * unusual pointer arithmetic (such as "abc" + 'd');
  * dereferenced null pointers;
  * incomplete statements;
  * misuse of iterators when iterating through a container;
  * dereferencing of erased iterators;
  * use of invalidated vector iterators/pointers
  .
  This package contains the graphical user interface for cppcheck.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

# for DEB_VERSION_UPSTREAM
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

DB2MAN      = /usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP          = xsltproc -''-nonet -''-param man.charmap.use.subset "0"
DESTDIR     = $(CURDIR)/debian/cppcheck
DESTDIR_GUI = $(CURDIR)/debian/cppcheck-gui

override_dh_auto_build:
	[ -f externals/tinyxml ] || mv externals/tinyxml externals/tinyxml.disabled
	dh_auto_build -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
		INCLUDE_FOR_LIB="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
	$(XP) $(DB2MAN) man/cppcheck.1.xml
	cd gui; qmake -qt=5 HAVE_RULES=yes
	sed -i -e 's/^CC\>/#CC/;s/^CXX\>/#CXX/;s/^CFLAGS *=/CFLAGS += $$(CPPFLAGS)/;s/^CXXFLAGS *=/CXXFLAGS += $$(CPPFLAGS)/;s/^LFLAGS *=/LFLAGS += $$(LDFLAGS)/' gui/Makefile
	dh_auto_build -- -C gui HAVE_RULES=yes CC="$(CC)" CXX="$(CXX)"
	sed -e "s/1.70/$(DEB_VERSION_UPSTREAM)/" debian/cppcheck-htmlreport.1.in >debian/cppcheck-htmlreport.1

override_dh_auto_clean:
	dh_auto_clean
	[ ! -f gui/Makefile ] || $(MAKE) -C gui clean
	rm -f gui/Makefile gui/cppcheck-gui gui/.qmake.stash
	rm -f debian/cppcheck-htmlreport.1
	[ ! -d externals/tinyxml.disabled ] || mv externals/tinyxml.disabled externals/tinyxml

override_dh_auto_test:
	dh_auto_test -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
		INCLUDE_FOR_LIB="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"

override_dh_auto_install:
	install -d ${DESTDIR}/usr/bin
	install cppcheck ${DESTDIR}/usr/bin
	install -d ${DESTDIR}/usr/share/cppcheck/cfg
	install -m 644 cfg/* ${DESTDIR}/usr/share/cppcheck/cfg
	install htmlreport/cppcheck-htmlreport ${DESTDIR}/usr/bin
	install -d ${DESTDIR}/usr/share/man/man1
	install debian/cppcheck-htmlreport.1 ${DESTDIR}/usr/share/man/man1
	# Changelog disabled because it is not up to date
	#	install -D -g 0 -o 0 -m 644 -p debian/changelog.upstream ${DESTDIR}/usr/share/doc/cppcheck/
	install -d ${DESTDIR_GUI}/usr/bin
	install gui/cppcheck-gui ${DESTDIR_GUI}/usr/bin

%:
	dh $@ --parallel --with python2

## cppcheck 1.82

=== CMakeLists.txt ===
project(CppCheck)
cmake_minimum_required(VERSION 2.8.4)

include(GNUInstallDirs)

include(cmake/versions.cmake REQUIRED)
include(cmake/options.cmake REQUIRED)
include(cmake/findDependencies.cmake REQUIRED)
include(cmake/compileroptions.cmake REQUIRED)
include(cmake/compilerDefinitions.cmake REQUIRED)
include(cmake/buildFiles.cmake REQUIRED)

file(GLOB cfgs "cfg/*.cfg")

if (BUILD_TESTS)
    enable_testing()
endif()

add_subdirectory(externals/tinyxml)
add_subdirectory(externals/simplecpp)
add_subdirectory(lib)   # CppCheck Library 
add_subdirectory(cli)   # Client application
add_subdirectory(test)  # Tests
ADD_SUBDIRECTORY(gui)   # Graphical application

include(cmake/printInfo.cmake REQUIRED)

=== cli/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/lib/)
include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)
include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")
file(GLOB mainfile "main.cpp")
list(REMOVE_ITEM srcs ${mainfile})

add_library(cli_objs OBJECT ${hdrs} ${srcs}) 
add_executable(cppcheck ${hdrs} ${mainfile} $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
if (HAVE_RULES)
    target_link_libraries(cppcheck pcre)
endif()
if (MSVC)
    target_link_libraries(cppcheck Shlwapi.lib)
endif()

install(TARGETS cppcheck
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}
    COMPONENT applications)

install(FILES ${cfgs}
   DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/${PROJECT_NAME}/
   COMPONENT headers)

=== gui/CMakeLists.txt ===
if (BUILD_GUI)

    set(CMAKE_AUTOMOC ON)
    if (${CMAKE_BUILD_TYPE} STREQUAL "Release")
        add_definitions(-DQT_NO_DEBUG)
        add_definitions(-DQT_NO_DEBUG_OUTPUT)
        add_definitions(-DQT_NO_WARNING_OUTPUT)
    else()
        add_definitions(-DQT_DEBUG)
    endif()

    include_directories(${PROJECT_SOURCE_DIR}/lib/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")
    file(GLOB uis  "*.ui")
    file(GLOB tss  "*.ts")
    QT5_WRAP_UI(uis_hdrs ${uis})
    QT5_ADD_RESOURCES(resources "gui.qrc")
    QT5_ADD_TRANSLATION(qms ${tss})

    add_executable(cppcheck-gui ${hdrs} ${srcs} ${uis_hdrs} ${resources} ${qms} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(cppcheck-gui pcre)
    endif()
    qt5_use_modules(cppcheck-gui ${GUI_QT_COMPONENTS})

    install(TARGETS cppcheck-gui RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)
    install(FILES ${qms} DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)

    install(FILES cppcheck-gui.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

    # icons
    install(FILES cppcheck-gui.svg DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
    install(FILES cppcheck-gui.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)

    set(CMAKE_AUTOMOC OFF)

endif()

=== test/CMakeLists.txt ===
if (BUILD_TESTS)

    include_directories(${PROJECT_SOURCE_DIR}/lib/ ${PROJECT_SOURCE_DIR}/cli/)
    include_directories(SYSTEM ${PROJECT_SOURCE_DIR}/externals/tinyxml)
    include_directories(${PROJECT_SOURCE_DIR}/externals/simplecpp/)

    file(GLOB hdrs "*.h")
    file(GLOB srcs "*.cpp")

    add_executable(testrunner ${hdrs} ${srcs} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:cli_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
    if (HAVE_RULES)
        target_link_libraries(testrunner pcre)
    endif()

    add_custom_target(copy_cfg ALL
        COMMENT "Copying cfg files")
    add_custom_command(
        TARGET copy_cfg
        COMMAND ${CMAKE_COMMAND} -E copy_directory "${PROJECT_SOURCE_DIR}/cfg"
            "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/cfg")

    add_dependencies(testrunner copy_cfg)

    add_test(NAME testrunner COMMAND testrunner WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

endif()

=== debian/changelog ===
cppcheck (1.82-1) unstable; urgency=medium

  * New upstream release.
  * Use debhelper compat version 11 (no changes needed).
  * Update Standards-Version to 4.1.3 (no changes needed).
  * Change Build-Depends: python-all to python3-all.
  * Change Depends: python-pygments to python3-pygments for cppcheck.
  * Fix lintian warnings file-contains-trailing-whitespace and
    override_dh_auto_test-does-not-check-DEB_BUILD_PROFILES.

 -- Joachim Reichel <reichel@debian.org>  Tue, 06 Feb 2018 20:49:13 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Section: devel
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
   docbook-xml, libpcre3-dev, libtinyxml2-dev, qt5-qmake, qtbase5-dev,
-  qtbase5-dev-tools, gdb, dh-python, python-all
-Standards-Version: 4.1.1
+  qtbase5-dev-tools, gdb, dh-python, python3-all
+Standards-Version: 4.1.3
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
 X-Python-Version: >= 2.6
 
 Package: cppcheck
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python-pygments
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
 Suggests: cppcheck-gui
 Description: tool for static C/C++ code analysis (CLI)
  Cppcheck is a command-line tool that tries to detect bugs that your

=== debian/rules ===
--- 
+++ 
@@ -32,10 +32,12 @@
 	[ ! -d externals/tinyxml.disabled ] || mv externals/tinyxml.disabled externals/tinyxml
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	dh_auto_test -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
 		INCLUDE_FOR_LIB="-Ilib -Iexternals/simplecpp" \
 		INCLUDE_FOR_CLI="-Ilib -Iexternals/simplecpp" \
 		INCLUDE_FOR_TEST="-Ilib -Icli -Iexternals/simplecpp"
+endif
 
 override_dh_auto_install:
 	install -d ${DESTDIR}/usr/bin
@@ -51,4 +53,4 @@
 	install gui/cppcheck-gui ${DESTDIR_GUI}/usr/bin
 
 %:
-	dh $@ --parallel --with python2
+	dh $@ --parallel --with python3

## cppcheck 1.83

=== debian/changelog ===
cppcheck (1.83-2) unstable; urgency=medium

  * Add versioned Build-Depends: libtinyxml2-dev (>= 6.2.0+dfsg-1). The
    layout of tinyxml2::XMLDocument was changed between 6.0.0 and 6.2.0
    without bumping the SONAME (Closes: #898327).

 -- Joachim Reichel <reichel@debian.org>  Sun, 13 May 2018 10:29:45 +0200

cppcheck (1.83-1) unstable; urgency=medium

  * New upstream release.
  * Add Suggests: python3, clang to cppcheck-gui.
  * Add patch fix-python-default to set default python path to
    /usr/bin/python3 in UI.
  * Change X-Python-Version: >= 2.6 to X-Python3-Version: >= 3.5 in
    debian/control, override shebang line to use /usr/bin/python3
    (Closes: #890305).
  * Update Standards-Version to 4.1.4 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Fri, 06 Apr 2018 09:23:15 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
-  docbook-xml, libpcre3-dev, libtinyxml2-dev, qt5-qmake, qtbase5-dev,
+  docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg-1), qt5-qmake, qtbase5-dev,
   qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
-X-Python-Version: >= 2.6
+X-Python3-Version: >= 3.5
 
 Package: cppcheck
 Architecture: any
@@ -52,6 +52,7 @@
 Package: cppcheck-gui
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: python3, clang
 Description: tool for static C/C++ code analysis (GUI)
  Cppcheck is a command-line tool that tries to detect bugs that your
  C/C++ compiler doesn't see. It is versatile, and can check non-standard

## cppcheck 1.84

=== debian/changelog ===
cppcheck (1.84-2) unstable; urgency=medium

  * Fix FTBFS due to char signedness (Closes: #905577).
  * Update Standards-Version to 4.1.5 (no changes needed).
  * Remove outdated upstream changelog.

 -- Joachim Reichel <reichel@debian.org>  Tue, 07 Aug 2018 22:36:03 +0200

cppcheck (1.84-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.1.5 (no changes needed).

 -- Joachim Reichel <reichel@debian.org>  Thu, 19 Jul 2018 19:18:23 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Joachim Reichel <reichel@debian.org>
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
-  docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg-1), qt5-qmake, qtbase5-dev,
+  docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
   qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.1.4
+Standards-Version: 4.2.0
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
 X-Python3-Version: >= 3.5

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,9 @@
 DESTDIR_GUI = $(CURDIR)/debian/cppcheck-gui
 
 override_dh_auto_build:
+	echo ld $LDFLAGS
+	echo env
+	set
 	[ -f externals/tinyxml ] || mv externals/tinyxml externals/tinyxml.disabled
 	dh_auto_build -- CFGDIR=/usr/share/cppcheck/cfg HAVE_RULES=yes LIBS=-ltinyxml2 \
 		INCLUDE_FOR_LIB="-Ilib -Iexternals/simplecpp" \
@@ -47,10 +50,11 @@
 	install htmlreport/cppcheck-htmlreport ${DESTDIR}/usr/bin
 	install -d ${DESTDIR}/usr/share/man/man1
 	install debian/cppcheck-htmlreport.1 ${DESTDIR}/usr/share/man/man1
-	# Changelog disabled because it is not up to date
-	#	install -D -g 0 -o 0 -m 644 -p debian/changelog.upstream ${DESTDIR}/usr/share/doc/cppcheck/
 	install -d ${DESTDIR_GUI}/usr/bin
 	install gui/cppcheck-gui ${DESTDIR_GUI}/usr/bin
 
+override_dh_python3:
+	dh_python3 --shebang=/usr/bin/python3
+
 %:
-	dh $@ --parallel --with python3
+	dh $@ --with python3

## cppcheck 1.85

=== debian/changelog ===
cppcheck (1.85-2) unstable; urgency=medium

  * Fix FTBFS due to char signedness: remove patch again, superseeded
    upstream (Closes: 914520).

 -- Joachim Reichel <reichel@debian.org>  Sat, 24 Nov 2018 16:49:56 +0100

cppcheck (1.85-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 (no changes needed).
  * Fix lintian warnings insecure-copyright-format-uri and
    description-contains-invalid-control-statement

 -- Joachim Reichel <reichel@debian.org>  Fri, 23 Nov 2018 17:32:14 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
   docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
   qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
 X-Python3-Version: >= 3.5
 
@@ -46,8 +46,8 @@
   * misuse of iterators when iterating through a container;
   * dereferencing of erased iterators;
   * use of invalidated vector iterators/pointers;
-  .
-  This package contains the command-line interface for cppcheck.
+ .
+ This package contains the command-line interface for cppcheck.
 
 Package: cppcheck-gui
 Architecture: any
@@ -86,5 +86,5 @@
   * misuse of iterators when iterating through a container;
   * dereferencing of erased iterators;
   * use of invalidated vector iterators/pointers
-  .
-  This package contains the graphical user interface for cppcheck.
+ .
+ This package contains the graphical user interface for cppcheck.

## cppcheck 1.86

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-project(CppCheck)
-cmake_minimum_required(VERSION 2.8.4)
+project(Cppcheck)
+cmake_minimum_required(VERSION 2.8.11)
 
 include(GNUInstallDirs)

=== Makefile ===
--- 
+++ 
@@ -80,7 +80,7 @@
     CPPCHK_GLIBCXX_DEBUG=
 endif
 ifndef CXXFLAGS
-    CXXFLAGS=-std=c++0x -O2 -include lib/cxx11emu.h -DNDEBUG -Wall -Wno-sign-compare
+    CXXFLAGS=-std=c++0x -O2 -DNDEBUG -Wall -Wno-sign-compare
 endif
 
 ifeq (g++, $(findstring g++,$(CXX)))
@@ -216,6 +216,7 @@
               test/testother.o \
               test/testpath.o \
               test/testpathmatch.o \
+              test/testplatform.o \
               test/testpostfixoperator.o \
               test/testpreprocessor.o \
               test/testrunner.o \
@@ -262,7 +263,7 @@
 check:	all
 	./testrunner -q
 
-checkcfg:	cppcheck validateCFG
+checkcfg:	cppcheck validateCFG validatePlatforms
 	./test/cfg/runtests.sh
 
 dmake:	tools/dmake.o cli/filelister.o $(SRCDIR)/pathmatch.o $(SRCDIR)/path.o externals/simplecpp/simplecpp.o
@@ -271,6 +272,8 @@
 run-dmake: dmake
 	./dmake
 
+generate_cfg_tests: tools/generate_cfg_tests.o $(EXTOBJ)
+	g++ -Iexternals/tinyxml -o generate_cfg_tests tools/generate_cfg_tests.o $(EXTOBJ)
 reduce:	tools/reduce.o $(LIBOBJ) $(EXTOBJ)
 	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)
 
@@ -284,7 +287,7 @@
 	$(XP) $(DB2MAN) $(MAN_SOURCE)
 
 tags:
-	ctags -R --exclude=doxyoutput --exclude=test/cfg cli externals gui lib test
+	ctags -R --exclude=doxyoutput --exclude=test/cfg --exclude=test/synthetic cli externals gui lib test
 
 install: cppcheck
 	install -d ${BIN}
@@ -297,6 +300,23 @@
 	install -m 644 cfg/* ${DESTDIR}${CFGDIR}
 endif
 
+uninstall:
+	@if test -d ${BIN}; then \
+	  files="cppcheck cppcheck-htmlreport \
+	    `ls -d addons/*.py addons/*/*.py 2>/dev/null | sed 's,^.*/,,'`"; \
+	  echo '(' cd ${BIN} '&&' rm -f $$files ')'; \
+	  ( cd ${BIN} && rm -f $$files ); \
+	fi
+ifdef CFGDIR 
+	@if test -d ${DESTDIR}${CFGDIR}; then \
+	  files="`cd cfg 2>/dev/null && ls`"; \
+	  if test -n "$$files"; then \
+	    echo '(' cd ${DESTDIR}${CFGDIR} '&&' rm -f $$files ')'; \
+	    ( cd ${DESTDIR}${CFGDIR} && rm -f $$files ); \
+	  fi; \
+	fi
+endif
+
 # Validation of library files:
 ConfigFiles := $(wildcard cfg/*.cfg)
 ConfigFilesCHECKED := $(patsubst %.cfg,%.checked,$(ConfigFiles))
@@ -305,25 +325,35 @@
 	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
 validateCFG: ${ConfigFilesCHECKED}
 
-
+# Validation of platforms files:
+PlatformFiles := $(wildcard platforms/*.xml)
+PlatformFilesCHECKED := $(patsubst %.xml,%.checked,$(PlatformFiles))
+.PHONY: validatePlatforms
+%.checked:%.xml
+	xmllint --noout --relaxng platforms/cppcheck-platforms.rng $<
+validatePlatforms: ${PlatformFilesCHECKED}
+
+# Validate XML output (to detect regressions)
+/tmp/errorlist.xml: cppcheck
+	./cppcheck --errorlist >$@
+/tmp/example.xml: cppcheck
+	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h -j 4 cli externals gui lib test 2>/tmp/example.xml
+createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
+.PHONY: validateXML
+validateXML: createXMLExamples
+	xmllint --noout --relaxng cppcheck-errors.rng /tmp/errorlist.xml
+	xmllint --noout --relaxng cppcheck-errors.rng /tmp/example.xml
+
+checkCWEEntries: /tmp/errorlist.xml
+	./tools/listErrorsWithoutCWE.py -F /tmp/errorlist.xml
 ###### Build
 
-$(SRCDIR)/analyzerinfo.o: lib/analyzerinfo.cpp lib/cxx11emu.h lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
+$(SRCDIR)/analyzerinfo.o: lib/analyzerinfo.cpp lib/analyzerinfo.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/importproject.h lib/platform.h lib/utils.h lib/path.h
 	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/analyzerinfo.o $(SRCDIR)/analyzerinfo.cpp
 
-$(SRCDIR)/astutils.o: lib/astutils.cpp lib/cxx11emu.h lib/astutils.h lib/library.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/mathlib.h lib/standards.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/timer.h lib/symboldatabase.h lib/token.h lib/valueflow.h
+$(SRCDIR)/astutils.o: lib/astutils.cpp lib/astutils.h lib/errorlogger.h lib/config.h lib/suppressions.h lib/library.h lib/mathlib.h lib/standards.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/timer.h lib/symboldatabase.h lib/token.h lib/valueflow.h
 	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/astutils.o $(SRCDIR)/astutils.cpp
 
-$(SRCDIR)/check.o: lib/check.cpp lib/cxx11emu.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h
+$(SRCDIR)/check.o: lib/check.cpp lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h
 	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/check.o $(SRCDIR)/check.cpp
 
-$(SRCDIR)/check64bit.o: lib/check64bit.cpp lib/cxx11emu.h lib/check64bit.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/symboldatabase.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/check64bit.o $(SRCDIR)/check64bit.cpp
-
-$(SRCDIR)/checkassert.o: lib/checkassert.cpp lib/cxx11emu.h lib/checkassert.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/symboldatabase.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/checkassert.o $(SRCDIR)/checkassert.cpp
-
-$(SRCDIR)/checkautovariables.o: lib/checkautovariables.cpp lib/cxx11emu.h lib/checkautovariables.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/astutils.h lib/symboldatabase.h
-	$(CXX) ${INCLUDE_FOR_LIB} $(CPPFLAGS) $(CFG) $(CXXFLAGS) $(UNDEF_STRICT_ANSI) -c -o $(SRCDIR)/checkautovariables.o $(SRCDIR)/checkautovariables.cpp
-
-$(SRCDIR)/checkbool.o: lib/checkbool.cpp lib/cxx11emu.h lib/checkbool.h lib/check.h lib/config.h lib/errorlogger.h lib/suppressions.h lib/settings.h lib/importproject.h lib/platform.h lib/utils.h lib/library.h lib/mathlib.h lib/standards.h lib/timer.h lib/token.h lib/valueflow.h lib/tokenize.h lib/tokenlist.h lib/astutils.h lib/symboldatabase.h

=== cli/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 if (HAVE_RULES)
     target_link_libraries(cppcheck pcre)
 endif()
-if (MSVC)
+if (WIN32 AND NOT BORLAND)
     target_link_libraries(cppcheck Shlwapi.lib)
 endif()

=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
     if (HAVE_RULES)
         target_link_libraries(cppcheck-gui pcre)
     endif()
-    qt5_use_modules(cppcheck-gui ${GUI_QT_COMPONENTS})
+    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
 
     install(TARGETS cppcheck-gui RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)
     install(FILES ${qms} DESTINATION ${CMAKE_INSTALL_FULL_BINDIR} COMPONENT applications)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,4 +23,7 @@
 
     add_test(NAME testrunner COMMAND testrunner WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
 
+    add_custom_target(check COMMAND $<TARGET_FILE:testrunner> -q WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
+    add_dependencies(check testrunner)
+
 endif()

=== externals/simplecpp/CMakeLists.txt ===
file(GLOB hdrs "*.h")
file(GLOB srcs "*.cpp")

add_library(simplecpp_objs OBJECT ${srcs} ${hdrs})

=== debian/changelog ===
cppcheck (1.86-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.3.0 (no changes needed).
  * Change patch fix-python-default to set the default python path to
    /usr/bin/python3; rename patch to fix-default-settings.
  * Extend patch to set the default DATADIR to /usr/share/cppcheck/cfg
    (Closes: #917630).
  * Fix typo in changelog of 1.85-2.

 -- Joachim Reichel <reichel@debian.org>  Sat, 29 Dec 2018 18:29:50 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.15.7~), xsltproc, docbook-xsl,
   docbook-xml, libpcre3-dev, libtinyxml2-dev (>= 6.2.0+dfsg), qt5-qmake, qtbase5-dev,
   qtbase5-dev-tools, gdb, dh-python, python3-all
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: http://sourceforge.net/p/cppcheck/wiki/Home/
 X-Python3-Version: >= 3.5
